PPanel Edge

bulk-operations

由 openapi.json 自动生成的 17 个端点及其请求、响应和权限元数据。

此参考由已发布 API 契约生成。字段、请求头和权限要求如下。

下载完整 OpenAPI 文档 · SHA-256: ccaa20cec11fad96e369b88073ce3608a5b071ce55d6dc03fa31df7b0f08c525

标识符和数据结构与公开契约一致,说明直接给出调用规则。共享模型见 数据模型.

GET /api/v1/admin/bulk-operations

GET /api/v1/admin/bulk-operations

List bulk operations

{
  "parameters": [
    {
      "in": "query",
      "name": "kind",
      "required": false,
      "schema": {
        "enum": [
          "compensation",
          "notification",
          "marketing"
        ],
        "type": "string"
      }
    },
    {
      "in": "query",
      "name": "status",
      "required": false,
      "schema": {
        "enum": [
          "draft",
          "previewed",
          "scheduled",
          "running",
          "paused",
          "completed",
          "cancelled",
          "failed"
        ],
        "type": "string"
      }
    },
    {
      "in": "query",
      "name": "cursor",
      "required": false,
      "schema": {
        "type": "string"
      }
    },
    {
      "in": "query",
      "name": "page_size",
      "required": false,
      "schema": {
        "default": 20,
        "maximum": 100,
        "minimum": 1,
        "type": "integer"
      }
    },
    {
      "in": "query",
      "name": "include_total",
      "required": false,
      "schema": {
        "default": "false",
        "enum": [
          "true",
          "false"
        ],
        "type": "string"
      }
    },
    {
      "in": "query",
      "name": "approval_required",
      "required": false,
      "schema": {
        "enum": [
          "true",
          "false"
        ],
        "type": "string"
      }
    }
  ],
  "responses": {
    "200": {
      "content": {
        "application/json": {
          "schema": {
            "properties": {
              "has_more": {
                "type": "boolean"
              },
              "items": {
                "items": {
                  "additionalProperties": {},
                  "properties": {
                    "id": {
                      "format": "uuid",
                      "type": "string"
                    },
                    "name": {
                      "type": "string"
                    },
                    "status": {
                      "type": "string"
                    },
                    "version": {
                      "type": "number"
                    }
                  },
                  "required": [
                    "id",
                    "name",
                    "status",
                    "version"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "next_cursor": {
                "type": [
                  "string",
                  "null"
                ]
              },
              "total": {
                "type": "number"
              }
            },
            "required": [
              "items",
              "next_cursor",
              "has_more"
            ],
            "type": "object"
          }
        }
      },
      "description": "Bulk operation"
    }
  },
  "summary": "List bulk operations",
  "tags": [
    "bulk-operations"
  ],
  "x-body": "none",
  "x-body-limit": 0,
  "x-permission": "ops.bulk.manage",
  "effectiveSecurity": []
}

POST /api/v1/admin/bulk-operations

POST /api/v1/admin/bulk-operations

Create a draft bulk operation

{
  "requestBody": {
    "content": {
      "application/json": {
        "schema": {
          "additionalProperties": false,
          "properties": {
            "actions": {
              "items": {
                "oneOf": [
                  {
                    "additionalProperties": false,
                    "properties": {
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "period_count": {
                        "maximum": 3650,
                        "minimum": 1,
                        "type": "integer"
                      },
                      "period_unit": {
                        "enum": [
                          "day",
                          "month",
                          "year"
                        ],
                        "type": "string"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "term_extend"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "period_unit",
                      "period_count"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "traffic_bytes": {
                        "pattern": "^[1-9][0-9]{0,17}$",
                        "type": "string"
                      },
                      "type": {
                        "enum": [
                          "traffic_bonus"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "traffic_bytes"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "device_delta": {
                        "maximum": 10000,
                        "minimum": 1,
                        "type": "integer"
                      },
                      "expires_at": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "device_bonus"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "device_delta"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "code_id": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "type": {
                        "enum": [
                          "issue_coupon"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "code_id"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "amount_minor": {
                        "pattern": "^[1-9][0-9]{0,17}$",
                        "type": "string"
                      },
                      "currency": {
                        "pattern": "^[A-Z]{3}$",
                        "type": "string"
                      },
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "type": {
                        "enum": [
                          "gift_credit"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "amount_minor",
                      "currency"
                    ],
                    "type": "object"
                  }
                ]
              },
              "maxItems": 20,
              "type": "array"
            },
            "audience": {
              "oneOf": [
                {
                  "additionalProperties": false,
                  "properties": {
                    "emails": {
                      "default": [],
                      "items": {
                        "format": "email",
                        "type": "string"
                      },
                      "maxItems": 10000,
                      "type": "array"
                    },
                    "type": {
                      "enum": [
                        "list"
                      ],
                      "type": "string"
                    },
                    "user_ids": {
                      "default": [],
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "maxItems": 10000,
                      "type": "array"
                    }
                  },
                  "required": [
                    "type"
                  ],
                  "type": "object"
                },
                {
                  "additionalProperties": false,
                  "properties": {
                    "created_from": {
                      "format": "date-time",
                      "type": "string"
                    },
                    "created_to": {
                      "format": "date-time",
                      "type": "string"
                    },
                    "has_active_subscription": {
                      "type": "boolean"
                    },
                    "invited_by": {
                      "format": "uuid",
                      "type": "string"
                    },
                    "locale": {
                      "maxLength": 35,
                      "type": "string"
                    },
                    "node_tags": {
                      "items": {
                        "maxLength": 64,
                        "type": "string"
                      },
                      "maxItems": 100,
                      "type": "array"
                    },
                    "plan_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "maxItems": 100,
                      "type": "array"
                    },
                    "server_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "maxItems": 100,
                      "type": "array"
                    },
                    "status": {
                      "items": {
                        "enum": [
                          "active",
                          "disabled",
                          "banned",
                          "deactivating",
                          "deleted"
                        ],
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "subscription_ends_from": {
                      "format": "date-time",
                      "type": "string"
                    },
                    "subscription_ends_to": {
                      "format": "date-time",
                      "type": "string"
                    },
                    "subscription_status": {
                      "items": {
                        "enum": [
                          "scheduled",
                          "active",
                          "exhausted",
                          "expired",
                          "cancelled",
                          "refunded"
                        ],
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "type": {
                      "enum": [
                        "query"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "type"
                  ],
                  "type": "object"
                }
              ]
            },
            "kind": {
              "enum": [
                "compensation",
                "notification",
                "marketing"
              ],
              "type": "string"
            },
            "name": {
              "maxLength": 200,
              "minLength": 1,
              "type": "string"
            },
            "notification": {
              "additionalProperties": false,
              "properties": {
                "channels": {
                  "items": {
                    "enum": [
                      "email",
                      "inbox",
                      "telegram"
                    ],
                    "type": "string"
                  },
                  "maxItems": 3,
                  "minItems": 1,
                  "type": "array"
                },
                "template_key": {
                  "pattern": "^[a-z][a-z0-9_.]{1,100}$",
                  "type": "string"
                },
                "values": {
                  "additionalProperties": {},
                  "default": {},
                  "type": "object"
                }
              },
              "required": [
                "template_key",
                "channels"
              ],
              "type": [
                "object",
                "null"
              ]
            }
          },
          "required": [
            "name",
            "kind",
            "audience",
            "actions",
            "notification"
          ],
          "type": "object"
        }
      }
    },
    "required": true
  },
  "responses": {
    "201": {
      "content": {
        "application/json": {
          "schema": {
            "properties": {
              "actions": {
                "items": {
                  "properties": {
                    "amount_minor": {
                      "type": "string"
                    },
                    "code_id": {
                      "format": "uuid",
                      "type": "string"
                    },
                    "currency": {
                      "type": "string"
                    },
                    "device_delta": {
                      "type": "number"
                    },
                    "expires_at": {
                      "type": "string"
                    },
                    "id": {
                      "type": "string"
                    },
                    "period_count": {
                      "type": "number"
                    },
                    "period_unit": {
                      "enum": [
                        "day",
                        "month",
                        "year"
                      ],
                      "type": "string"
                    },
                    "plan_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "traffic_bytes": {
                      "type": "string"
                    },
                    "type": {
                      "enum": [
                        "term_extend",
                        "traffic_bonus",
                        "device_bonus",
                        "issue_coupon",
                        "gift_credit"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "id",
                    "type"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "audience": {
                "oneOf": [
                  {
                    "additionalProperties": false,
                    "properties": {
                      "emails": {
                        "default": [],
                        "items": {
                          "format": "email",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "list"
                        ],
                        "type": "string"
                      },
                      "user_ids": {
                        "default": [],
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "created_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "created_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "has_active_subscription": {
                        "type": "boolean"
                      },
                      "invited_by": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "locale": {
                        "maxLength": 35,
                        "type": "string"
                      },
                      "node_tags": {
                        "items": {
                          "maxLength": 64,
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "server_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "status": {
                        "items": {
                          "enum": [
                            "active",
                            "disabled",
                            "banned",
                            "deactivating",
                            "deleted"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "subscription_ends_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "subscription_ends_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "subscription_status": {
                        "items": {
                          "enum": [
                            "scheduled",
                            "active",
                            "exhausted",
                            "expired",
                            "cancelled",
                            "refunded"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "query"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  }
                ]
              },
              "created_by": {
                "format": "uuid",
                "type": "string"
              },
              "done_count": {
                "type": "number"
              },
              "executed_by": {
                "format": "uuid",
                "type": [
                  "string",
                  "null"
                ]
              },
              "failed_count": {
                "type": "number"
              },
              "failures": {
                "items": {
                  "properties": {
                    "reason": {
                      "type": "string"
                    },
                    "user_id": {
                      "format": "uuid",
                      "type": "string"
                    }
                  },
                  "required": [
                    "user_id",
                    "reason"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "id": {
                "format": "uuid",
                "type": "string"
              },
              "kind": {
                "enum": [
                  "compensation",
                  "notification",
                  "marketing"
                ],
                "type": "string"
              },
              "name": {
                "type": "string"
              },
              "notification": {
                "additionalProperties": false,
                "properties": {
                  "channels": {
                    "items": {
                      "enum": [
                        "email",
                        "inbox",
                        "telegram"
                      ],
                      "type": "string"
                    },
                    "maxItems": 3,
                    "minItems": 1,
                    "type": "array"
                  },
                  "template_key": {
                    "pattern": "^[a-z][a-z0-9_.]{1,100}$",
                    "type": "string"
                  },
                  "values": {
                    "additionalProperties": {},
                    "default": {},
                    "type": "object"
                  }
                },
                "required": [
                  "template_key",
                  "channels"
                ],
                "type": [
                  "object",
                  "null"
                ]
              },
              "preview": {
                "properties": {
                  "actions": {
                    "items": {
                      "properties": {
                        "amount_minor": {
                          "type": "string"
                        },
                        "code_id": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "currency": {
                          "type": "string"
                        },
                        "device_delta": {
                          "type": "number"
                        },
                        "expires_at": {
                          "type": "string"
                        },
                        "id": {
                          "type": "string"
                        },
                        "period_count": {
                          "type": "number"
                        },
                        "period_unit": {
                          "enum": [
                            "day",
                            "month",
                            "year"
                          ],
                          "type": "string"
                        },
                        "plan_ids": {
                          "items": {
                            "format": "uuid",
                            "type": "string"
                          },
                          "type": "array"
                        },
                        "traffic_bytes": {
                          "type": "string"
                        },
                        "type": {
                          "enum": [
                            "term_extend",
                            "traffic_bonus",
                            "device_bonus",
                            "issue_coupon",
                            "gift_credit"
                          ],
                          "type": "string"
                        }
                      },
                      "required": [
                        "id",
                        "type"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  },
                  "approval_required": {
                    "type": "boolean"
                  },
                  "approved_at": {
                    "type": "string"
                  },
                  "approved_by": {
                    "format": "uuid",
                    "type": "string"
                  },
                  "at": {
                    "type": "string"
                  },
                  "audience_hash": {
                    "type": "string"
                  },
                  "count": {
                    "type": "number"
                  },
                  "notification_missing_templates": {
                    "items": {
                      "properties": {
                        "channel": {
                          "type": "string"
                        },
                        "locale": {
                          "type": "string"
                        }
                      },
                      "required": [
                        "channel",
                        "locale"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  },
                  "sample": {
                    "items": {
                      "properties": {
                        "id": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "public_id": {
                          "type": "string"
                        }
                      },
                      "required": [
                        "id",
                        "public_id"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  }
                },
                "required": [
                  "count",
                  "sample",
                  "at",
                  "actions"
                ],
                "type": [
                  "object",
                  "null"
                ]
              },
              "scheduled_at": {
                "type": [
                  "string",
                  "null"
                ]
              },
              "skipped_count": {
                "type": "number"
              },
              "status": {
                "type": "string"
              },
              "target_count": {
                "type": [
                  "number",
                  "null"
                ]
              },
              "version": {
                "type": "integer"
              }
            },
            "required": [
              "id",
              "name",
              "kind",
              "scheduled_at",
              "audience",
              "actions",
              "notification",
              "status",
              "version",
              "preview",
              "target_count",
              "done_count",
              "skipped_count",
              "failed_count",
              "failures",
              "created_by",
              "executed_by"
            ],
            "type": "object"
          }
        }
      },
      "description": "Bulk operation",
      "headers": {
        "ETag": {
          "description": "Current resource version for If-Match.",
          "schema": {
            "type": "string"
          }
        }
      }
    }
  },
  "summary": "Create a draft bulk operation",
  "tags": [
    "bulk-operations"
  ],
  "x-audit": "ops.bulk.create",
  "x-body": "json",
  "x-body-limit": 1048576,
  "x-concurrency": {
    "etag": true
  },
  "x-idempotency": "required",
  "x-permission": "ops.bulk.manage",
  "effectiveSecurity": []
}

GET /api/v1/admin/bulk-operations/{id}

GET /api/v1/admin/bulk-operations/{id}

Read a bulk operation

{
  "parameters": [
    {
      "in": "path",
      "name": "id",
      "required": true,
      "schema": {
        "format": "uuid",
        "type": "string"
      }
    }
  ],
  "responses": {
    "200": {
      "content": {
        "application/json": {
          "schema": {
            "properties": {
              "actions": {
                "items": {
                  "properties": {
                    "amount_minor": {
                      "type": "string"
                    },
                    "code_id": {
                      "format": "uuid",
                      "type": "string"
                    },
                    "currency": {
                      "type": "string"
                    },
                    "device_delta": {
                      "type": "number"
                    },
                    "expires_at": {
                      "type": "string"
                    },
                    "id": {
                      "type": "string"
                    },
                    "period_count": {
                      "type": "number"
                    },
                    "period_unit": {
                      "enum": [
                        "day",
                        "month",
                        "year"
                      ],
                      "type": "string"
                    },
                    "plan_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "traffic_bytes": {
                      "type": "string"
                    },
                    "type": {
                      "enum": [
                        "term_extend",
                        "traffic_bonus",
                        "device_bonus",
                        "issue_coupon",
                        "gift_credit"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "id",
                    "type"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "audience": {
                "oneOf": [
                  {
                    "additionalProperties": false,
                    "properties": {
                      "emails": {
                        "default": [],
                        "items": {
                          "format": "email",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "list"
                        ],
                        "type": "string"
                      },
                      "user_ids": {
                        "default": [],
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "created_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "created_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "has_active_subscription": {
                        "type": "boolean"
                      },
                      "invited_by": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "locale": {
                        "maxLength": 35,
                        "type": "string"
                      },
                      "node_tags": {
                        "items": {
                          "maxLength": 64,
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "server_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "status": {
                        "items": {
                          "enum": [
                            "active",
                            "disabled",
                            "banned",
                            "deactivating",
                            "deleted"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "subscription_ends_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "subscription_ends_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "subscription_status": {
                        "items": {
                          "enum": [
                            "scheduled",
                            "active",
                            "exhausted",
                            "expired",
                            "cancelled",
                            "refunded"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "query"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  }
                ]
              },
              "created_by": {
                "format": "uuid",
                "type": "string"
              },
              "done_count": {
                "type": "number"
              },
              "executed_by": {
                "format": "uuid",
                "type": [
                  "string",
                  "null"
                ]
              },
              "failed_count": {
                "type": "number"
              },
              "failures": {
                "items": {
                  "properties": {
                    "reason": {
                      "type": "string"
                    },
                    "user_id": {
                      "format": "uuid",
                      "type": "string"
                    }
                  },
                  "required": [
                    "user_id",
                    "reason"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "id": {
                "format": "uuid",
                "type": "string"
              },
              "kind": {
                "enum": [
                  "compensation",
                  "notification",
                  "marketing"
                ],
                "type": "string"
              },
              "name": {
                "type": "string"
              },
              "notification": {
                "additionalProperties": false,
                "properties": {
                  "channels": {
                    "items": {
                      "enum": [
                        "email",
                        "inbox",
                        "telegram"
                      ],
                      "type": "string"
                    },
                    "maxItems": 3,
                    "minItems": 1,
                    "type": "array"
                  },
                  "template_key": {
                    "pattern": "^[a-z][a-z0-9_.]{1,100}$",
                    "type": "string"
                  },
                  "values": {
                    "additionalProperties": {},
                    "default": {},
                    "type": "object"
                  }
                },
                "required": [
                  "template_key",
                  "channels"
                ],
                "type": [
                  "object",
                  "null"
                ]
              },
              "preview": {
                "properties": {
                  "actions": {
                    "items": {
                      "properties": {
                        "amount_minor": {
                          "type": "string"
                        },
                        "code_id": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "currency": {
                          "type": "string"
                        },
                        "device_delta": {
                          "type": "number"
                        },
                        "expires_at": {
                          "type": "string"
                        },
                        "id": {
                          "type": "string"
                        },
                        "period_count": {
                          "type": "number"
                        },
                        "period_unit": {
                          "enum": [
                            "day",
                            "month",
                            "year"
                          ],
                          "type": "string"
                        },
                        "plan_ids": {
                          "items": {
                            "format": "uuid",
                            "type": "string"
                          },
                          "type": "array"
                        },
                        "traffic_bytes": {
                          "type": "string"
                        },
                        "type": {
                          "enum": [
                            "term_extend",
                            "traffic_bonus",
                            "device_bonus",
                            "issue_coupon",
                            "gift_credit"
                          ],
                          "type": "string"
                        }
                      },
                      "required": [
                        "id",
                        "type"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  },
                  "approval_required": {
                    "type": "boolean"
                  },
                  "approved_at": {
                    "type": "string"
                  },
                  "approved_by": {
                    "format": "uuid",
                    "type": "string"
                  },
                  "at": {
                    "type": "string"
                  },
                  "audience_hash": {
                    "type": "string"
                  },
                  "count": {
                    "type": "number"
                  },
                  "notification_missing_templates": {
                    "items": {
                      "properties": {
                        "channel": {
                          "type": "string"
                        },
                        "locale": {
                          "type": "string"
                        }
                      },
                      "required": [
                        "channel",
                        "locale"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  },
                  "sample": {
                    "items": {
                      "properties": {
                        "id": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "public_id": {
                          "type": "string"
                        }
                      },
                      "required": [
                        "id",
                        "public_id"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  }
                },
                "required": [
                  "count",
                  "sample",
                  "at",
                  "actions"
                ],
                "type": [
                  "object",
                  "null"
                ]
              },
              "scheduled_at": {
                "type": [
                  "string",
                  "null"
                ]
              },
              "skipped_count": {
                "type": "number"
              },
              "status": {
                "type": "string"
              },
              "target_count": {
                "type": [
                  "number",
                  "null"
                ]
              },
              "version": {
                "type": "integer"
              }
            },
            "required": [
              "id",
              "name",
              "kind",
              "scheduled_at",
              "audience",
              "actions",
              "notification",
              "status",
              "version",
              "preview",
              "target_count",
              "done_count",
              "skipped_count",
              "failed_count",
              "failures",
              "created_by",
              "executed_by"
            ],
            "type": "object"
          }
        }
      },
      "description": "Bulk operation",
      "headers": {
        "ETag": {
          "description": "Current resource version for If-Match.",
          "schema": {
            "type": "string"
          }
        }
      }
    }
  },
  "summary": "Read a bulk operation",
  "tags": [
    "bulk-operations"
  ],
  "x-body": "none",
  "x-body-limit": 0,
  "x-concurrency": {
    "etag": true
  },
  "x-permission": "ops.bulk.manage",
  "effectiveSecurity": []
}

PATCH /api/v1/admin/bulk-operations/{id}

PATCH /api/v1/admin/bulk-operations/{id}

Edit a draft and invalidate its preview

{
  "parameters": [
    {
      "in": "path",
      "name": "id",
      "required": true,
      "schema": {
        "format": "uuid",
        "type": "string"
      }
    },
    {
      "description": "Resource ETag; missing 428, malformed 412, stale 409.",
      "in": "header",
      "name": "If-Match",
      "required": true,
      "schema": {
        "type": "string"
      }
    }
  ],
  "requestBody": {
    "content": {
      "application/json": {
        "schema": {
          "additionalProperties": false,
          "properties": {
            "actions": {
              "items": {
                "oneOf": [
                  {
                    "additionalProperties": false,
                    "properties": {
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "period_count": {
                        "maximum": 3650,
                        "minimum": 1,
                        "type": "integer"
                      },
                      "period_unit": {
                        "enum": [
                          "day",
                          "month",
                          "year"
                        ],
                        "type": "string"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "term_extend"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "period_unit",
                      "period_count"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "traffic_bytes": {
                        "pattern": "^[1-9][0-9]{0,17}$",
                        "type": "string"
                      },
                      "type": {
                        "enum": [
                          "traffic_bonus"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "traffic_bytes"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "device_delta": {
                        "maximum": 10000,
                        "minimum": 1,
                        "type": "integer"
                      },
                      "expires_at": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "device_bonus"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "device_delta"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "code_id": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "type": {
                        "enum": [
                          "issue_coupon"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "code_id"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "amount_minor": {
                        "pattern": "^[1-9][0-9]{0,17}$",
                        "type": "string"
                      },
                      "currency": {
                        "pattern": "^[A-Z]{3}$",
                        "type": "string"
                      },
                      "id": {
                        "pattern": "^[a-z][a-z0-9_]{0,31}$",
                        "type": "string"
                      },
                      "type": {
                        "enum": [
                          "gift_credit"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "id",
                      "type",
                      "amount_minor",
                      "currency"
                    ],
                    "type": "object"
                  }
                ]
              },
              "maxItems": 20,
              "type": "array"
            },
            "audience": {
              "oneOf": [
                {
                  "additionalProperties": false,
                  "properties": {
                    "emails": {
                      "default": [],
                      "items": {
                        "format": "email",
                        "type": "string"
                      },
                      "maxItems": 10000,
                      "type": "array"
                    },
                    "type": {
                      "enum": [
                        "list"
                      ],
                      "type": "string"
                    },
                    "user_ids": {
                      "default": [],
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "maxItems": 10000,
                      "type": "array"
                    }
                  },
                  "required": [
                    "type"
                  ],
                  "type": "object"
                },
                {
                  "additionalProperties": false,
                  "properties": {
                    "created_from": {
                      "format": "date-time",
                      "type": "string"
                    },
                    "created_to": {
                      "format": "date-time",
                      "type": "string"
                    },
                    "has_active_subscription": {
                      "type": "boolean"
                    },
                    "invited_by": {
                      "format": "uuid",
                      "type": "string"
                    },
                    "locale": {
                      "maxLength": 35,
                      "type": "string"
                    },
                    "node_tags": {
                      "items": {
                        "maxLength": 64,
                        "type": "string"
                      },
                      "maxItems": 100,
                      "type": "array"
                    },
                    "plan_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "maxItems": 100,
                      "type": "array"
                    },
                    "server_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "maxItems": 100,
                      "type": "array"
                    },
                    "status": {
                      "items": {
                        "enum": [
                          "active",
                          "disabled",
                          "banned",
                          "deactivating",
                          "deleted"
                        ],
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "subscription_ends_from": {
                      "format": "date-time",
                      "type": "string"
                    },
                    "subscription_ends_to": {
                      "format": "date-time",
                      "type": "string"
                    },
                    "subscription_status": {
                      "items": {
                        "enum": [
                          "scheduled",
                          "active",
                          "exhausted",
                          "expired",
                          "cancelled",
                          "refunded"
                        ],
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "type": {
                      "enum": [
                        "query"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "type"
                  ],
                  "type": "object"
                }
              ]
            },
            "kind": {
              "enum": [
                "compensation",
                "notification",
                "marketing"
              ],
              "type": "string"
            },
            "name": {
              "maxLength": 200,
              "minLength": 1,
              "type": "string"
            },
            "notification": {
              "additionalProperties": false,
              "properties": {
                "channels": {
                  "items": {
                    "enum": [
                      "email",
                      "inbox",
                      "telegram"
                    ],
                    "type": "string"
                  },
                  "maxItems": 3,
                  "minItems": 1,
                  "type": "array"
                },
                "template_key": {
                  "pattern": "^[a-z][a-z0-9_.]{1,100}$",
                  "type": "string"
                },
                "values": {
                  "additionalProperties": {},
                  "default": {},
                  "type": "object"
                }
              },
              "required": [
                "template_key",
                "channels"
              ],
              "type": [
                "object",
                "null"
              ]
            }
          },
          "required": [
            "name",
            "kind",
            "audience",
            "actions",
            "notification"
          ],
          "type": "object"
        }
      }
    },
    "required": true
  },
  "responses": {
    "200": {
      "content": {
        "application/json": {
          "schema": {
            "properties": {
              "actions": {
                "items": {
                  "properties": {
                    "amount_minor": {
                      "type": "string"
                    },
                    "code_id": {
                      "format": "uuid",
                      "type": "string"
                    },
                    "currency": {
                      "type": "string"
                    },
                    "device_delta": {
                      "type": "number"
                    },
                    "expires_at": {
                      "type": "string"
                    },
                    "id": {
                      "type": "string"
                    },
                    "period_count": {
                      "type": "number"
                    },
                    "period_unit": {
                      "enum": [
                        "day",
                        "month",
                        "year"
                      ],
                      "type": "string"
                    },
                    "plan_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "traffic_bytes": {
                      "type": "string"
                    },
                    "type": {
                      "enum": [
                        "term_extend",
                        "traffic_bonus",
                        "device_bonus",
                        "issue_coupon",
                        "gift_credit"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "id",
                    "type"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "audience": {
                "oneOf": [
                  {
                    "additionalProperties": false,
                    "properties": {
                      "emails": {
                        "default": [],
                        "items": {
                          "format": "email",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "list"
                        ],
                        "type": "string"
                      },
                      "user_ids": {
                        "default": [],
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "created_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "created_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "has_active_subscription": {
                        "type": "boolean"
                      },
                      "invited_by": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "locale": {
                        "maxLength": 35,
                        "type": "string"
                      },
                      "node_tags": {
                        "items": {
                          "maxLength": 64,
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "server_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "status": {
                        "items": {
                          "enum": [
                            "active",
                            "disabled",
                            "banned",
                            "deactivating",
                            "deleted"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "subscription_ends_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "subscription_ends_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "subscription_status": {
                        "items": {
                          "enum": [
                            "scheduled",
                            "active",
                            "exhausted",
                            "expired",
                            "cancelled",
                            "refunded"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "query"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  }
                ]
              },
              "created_by": {
                "format": "uuid",
                "type": "string"
              },
              "done_count": {
                "type": "number"
              },
              "executed_by": {
                "format": "uuid",
                "type": [
                  "string",
                  "null"
                ]
              },
              "failed_count": {
                "type": "number"
              },
              "failures": {
                "items": {
                  "properties": {
                    "reason": {
                      "type": "string"
                    },
                    "user_id": {
                      "format": "uuid",
                      "type": "string"
                    }
                  },
                  "required": [
                    "user_id",
                    "reason"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "id": {
                "format": "uuid",
                "type": "string"
              },
              "kind": {
                "enum": [
                  "compensation",
                  "notification",
                  "marketing"
                ],
                "type": "string"
              },
              "name": {
                "type": "string"
              },
              "notification": {
                "additionalProperties": false,
                "properties": {
                  "channels": {
                    "items": {
                      "enum": [
                        "email",
                        "inbox",
                        "telegram"
                      ],
                      "type": "string"
                    },
                    "maxItems": 3,
                    "minItems": 1,
                    "type": "array"
                  },
                  "template_key": {
                    "pattern": "^[a-z][a-z0-9_.]{1,100}$",
                    "type": "string"
                  },
                  "values": {
                    "additionalProperties": {},
                    "default": {},
                    "type": "object"
                  }
                },
                "required": [
                  "template_key",
                  "channels"
                ],
                "type": [
                  "object",
                  "null"
                ]
              },
              "preview": {
                "properties": {
                  "actions": {
                    "items": {
                      "properties": {
                        "amount_minor": {
                          "type": "string"
                        },
                        "code_id": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "currency": {
                          "type": "string"
                        },
                        "device_delta": {
                          "type": "number"
                        },
                        "expires_at": {
                          "type": "string"
                        },
                        "id": {
                          "type": "string"
                        },
                        "period_count": {
                          "type": "number"
                        },
                        "period_unit": {
                          "enum": [
                            "day",
                            "month",
                            "year"
                          ],
                          "type": "string"
                        },
                        "plan_ids": {
                          "items": {
                            "format": "uuid",
                            "type": "string"
                          },
                          "type": "array"
                        },
                        "traffic_bytes": {
                          "type": "string"
                        },
                        "type": {
                          "enum": [
                            "term_extend",
                            "traffic_bonus",
                            "device_bonus",
                            "issue_coupon",
                            "gift_credit"
                          ],
                          "type": "string"
                        }
                      },
                      "required": [
                        "id",
                        "type"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  },
                  "approval_required": {
                    "type": "boolean"
                  },
                  "approved_at": {
                    "type": "string"
                  },
                  "approved_by": {
                    "format": "uuid",
                    "type": "string"
                  },
                  "at": {
                    "type": "string"
                  },
                  "audience_hash": {
                    "type": "string"
                  },
                  "count": {
                    "type": "number"
                  },
                  "notification_missing_templates": {
                    "items": {
                      "properties": {
                        "channel": {
                          "type": "string"
                        },
                        "locale": {
                          "type": "string"
                        }
                      },
                      "required": [
                        "channel",
                        "locale"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  },
                  "sample": {
                    "items": {
                      "properties": {
                        "id": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "public_id": {
                          "type": "string"
                        }
                      },
                      "required": [
                        "id",
                        "public_id"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  }
                },
                "required": [
                  "count",
                  "sample",
                  "at",
                  "actions"
                ],
                "type": [
                  "object",
                  "null"
                ]
              },
              "scheduled_at": {
                "type": [
                  "string",
                  "null"
                ]
              },
              "skipped_count": {
                "type": "number"
              },
              "status": {
                "type": "string"
              },
              "target_count": {
                "type": [
                  "number",
                  "null"
                ]
              },
              "version": {
                "type": "integer"
              }
            },
            "required": [
              "id",
              "name",
              "kind",
              "scheduled_at",
              "audience",
              "actions",
              "notification",
              "status",
              "version",
              "preview",
              "target_count",
              "done_count",
              "skipped_count",
              "failed_count",
              "failures",
              "created_by",
              "executed_by"
            ],
            "type": "object"
          }
        }
      },
      "description": "Bulk operation",
      "headers": {
        "ETag": {
          "description": "Current resource version for If-Match.",
          "schema": {
            "type": "string"
          }
        }
      }
    },
    "403": {
      "content": {
        "application/problem+json": {
          "schema": {
            "properties": {
              "code": {
                "type": "string"
              },
              "request_id": {
                "type": "string"
              },
              "status": {
                "type": "number"
              },
              "title": {
                "type": "string"
              },
              "type": {
                "type": "string"
              }
            },
            "required": [
              "code",
              "status",
              "title",
              "type",
              "request_id"
            ],
            "type": "object"
          }
        }
      },
      "description": "Command refused"
    },
    "409": {
      "content": {
        "application/problem+json": {
          "schema": {
            "properties": {
              "code": {
                "type": "string"
              },
              "request_id": {
                "type": "string"
              },
              "status": {
                "type": "number"
              },
              "title": {
                "type": "string"
              },
              "type": {
                "type": "string"
              }
            },
            "required": [
              "code",
              "status",
              "title",
              "type",
              "request_id"
            ],
            "type": "object"
          }
        }
      },
      "description": "Command refused"
    },
    "428": {
      "content": {
        "application/problem+json": {
          "schema": {
            "properties": {
              "code": {
                "type": "string"
              },
              "request_id": {
                "type": "string"
              },
              "status": {
                "type": "number"
              },
              "title": {
                "type": "string"
              },
              "type": {
                "type": "string"
              }
            },
            "required": [
              "code",
              "status",
              "title",
              "type",
              "request_id"
            ],
            "type": "object"
          }
        }
      },
      "description": "Command refused"
    }
  },
  "summary": "Edit a draft and invalidate its preview",
  "tags": [
    "bulk-operations"
  ],
  "x-audit": "ops.bulk.update",
  "x-body": "json",
  "x-body-limit": 1048576,
  "x-concurrency": {
    "etag": true,
    "ifMatch": true
  },
  "x-idempotency": "optional",
  "x-permission": "ops.bulk.manage",
  "effectiveSecurity": []
}

POST /api/v1/admin/bulk-operations/{id}/approve

POST /api/v1/admin/bulk-operations/{id}/approve

Approve the current preview as a second staff member

{
  "parameters": [
    {
      "in": "path",
      "name": "id",
      "required": true,
      "schema": {
        "format": "uuid",
        "type": "string"
      }
    },
    {
      "description": "Resource ETag; missing 428, malformed 412, stale 409.",
      "in": "header",
      "name": "If-Match",
      "required": true,
      "schema": {
        "type": "string"
      }
    }
  ],
  "responses": {
    "200": {
      "content": {
        "application/json": {
          "schema": {
            "properties": {
              "actions": {
                "items": {
                  "properties": {
                    "amount_minor": {
                      "type": "string"
                    },
                    "code_id": {
                      "format": "uuid",
                      "type": "string"
                    },
                    "currency": {
                      "type": "string"
                    },
                    "device_delta": {
                      "type": "number"
                    },
                    "expires_at": {
                      "type": "string"
                    },
                    "id": {
                      "type": "string"
                    },
                    "period_count": {
                      "type": "number"
                    },
                    "period_unit": {
                      "enum": [
                        "day",
                        "month",
                        "year"
                      ],
                      "type": "string"
                    },
                    "plan_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "traffic_bytes": {
                      "type": "string"
                    },
                    "type": {
                      "enum": [
                        "term_extend",
                        "traffic_bonus",
                        "device_bonus",
                        "issue_coupon",
                        "gift_credit"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "id",
                    "type"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "audience": {
                "oneOf": [
                  {
                    "additionalProperties": false,
                    "properties": {
                      "emails": {
                        "default": [],
                        "items": {
                          "format": "email",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "list"
                        ],
                        "type": "string"
                      },
                      "user_ids": {
                        "default": [],
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "created_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "created_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "has_active_subscription": {
                        "type": "boolean"
                      },
                      "invited_by": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "locale": {
                        "maxLength": 35,
                        "type": "string"
                      },
                      "node_tags": {
                        "items": {
                          "maxLength": 64,
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "server_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "status": {
                        "items": {
                          "enum": [
                            "active",
                            "disabled",
                            "banned",
                            "deactivating",
                            "deleted"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "subscription_ends_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "subscription_ends_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "subscription_status": {
                        "items": {
                          "enum": [
                            "scheduled",
                            "active",
                            "exhausted",
                            "expired",
                            "cancelled",
                            "refunded"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "query"
                        ],
                        "type": "string"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  }
                ]
              },
              "created_by": {
                "format": "uuid",
                "type": "string"
              },
              "done_count": {
                "type": "number"
              },
              "executed_by": {
                "format": "uuid",
                "type": [
                  "string",
                  "null"
                ]
              },
              "failed_count": {
                "type": "number"
              },
              "failures": {
                "items": {
                  "properties": {
                    "reason": {
                      "type": "string"
                    },
                    "user_id": {
                      "format": "uuid",
                      "type": "string"
                    }
                  },
                  "required": [
                    "user_id",
                    "reason"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "id": {
                "format": "uuid",
                "type": "string"
              },
              "kind": {
                "enum": [
                  "compensation",
                  "notification",
                  "marketing"
                ],
                "type": "string"
              },
              "name": {
                "type": "string"
              },
              "notification": {
                "additionalProperties": false,
                "properties": {
                  "channels": {
                    "items": {
                      "enum": [
                        "email",
                        "inbox",
                        "telegram"
                      ],
                      "type": "string"
                    },
                    "maxItems": 3,
                    "minItems": 1,
                    "type": "array"
                  },
                  "template_key": {
                    "pattern": "^[a-z][a-z0-9_.]{1,100}$",
                    "type": "string"
                  },
                  "values": {
                    "additionalProperties": {},
                    "default": {},
                    "type": "object"
                  }
                },
                "required": [
                  "template_key",
                  "channels"
                ],
                "type": [
                  "object",
                  "null"
                ]
              },
              "preview": {
                "properties": {
                  "actions": {
                    "items": {
                      "properties": {
                        "amount_minor": {
                          "type": "string"
                        },
                        "code_id": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "currency": {
                          "type": "string"
                        },
                        "device_delta": {
                          "type": "number"
                        },
                        "expires_at": {
                          "type": "string"
                        },
                        "id": {
                          "type": "string"
                        },
                        "period_count": {
                          "type": "number"
                        },
                        "period_unit": {
                          "enum": [
                            "day",
                            "month",
                            "year"
                          ],
                          "type": "string"
                        },
                        "plan_ids": {
                          "items": {
                            "format": "uuid",
                            "type": "string"
                          },
                          "type": "array"
                        },
                        "traffic_bytes": {
                          "type": "string"
                        },
                        "type": {
                          "enum": [
                            "term_extend",
                            "traffic_bonus",
                            "device_bonus",
                            "issue_coupon",
                            "gift_credit"
                          ],
                          "type": "string"
                        }
                      },
                      "required": [
                        "id",
                        "type"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  },
                  "approval_required": {
                    "type": "boolean"
                  },
                  "approved_at": {
                    "type": "string"
                  },
                  "approved_by": {
                    "format": "uuid",
                    "type": "string"
                  },
                  "at": {
                    "type": "string"
                  },
                  "audience_hash": {
                    "type": "string"
                  },
                  "count": {
                    "type": "number"
                  },
                  "notification_missing_templates": {
                    "items": {
                      "properties": {
                        "channel": {
                          "type": "string"
                        },
                        "locale": {
                          "type": "string"
                        }
                      },
                      "required": [
                        "channel",
                        "locale"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  },
                  "sample": {
                    "items": {
                      "properties": {
                        "id": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "public_id": {
                          "type": "string"
                        }
                      },
                      "required": [
                        "id",
                        "public_id"
                      ],
                      "type": "object"
                    },
                    "type": "array"
                  }
                },
                "required": [
                  "count",
                  "sample",
                  "at",
                  "actions"
                ],
                "type": [
                  "object",
                  "null"
                ]
              },
              "scheduled_at": {
                "type": [
                  "string",
                  "null"
                ]
              },
              "skipped_count": {
                "type": "number"
              },
              "status": {
                "type": "string"
              },
              "target_count": {
                "type": [
                  "number",
                  "null"
                ]
              },
              "version": {
                "type": "integer"
              }
            },
            "required": [
              "id",
              "name",
              "kind",
              "scheduled_at",
              "audience",
              "actions",
              "notification",
              "status",
              "version",
              "preview",
              "target_count",
              "done_count",
              "skipped_count",
              "failed_count",
              "failures",
              "created_by",
              "executed_by"
            ],
            "type": "object"
          }
        }
      },
      "description": "Bulk operation",
      "headers": {
        "ETag": {
          "description": "Current resource version for If-Match.",
          "schema": {
            "type": "string"
          }
        }
      }
    },
    "403": {
      "content": {
        "application/problem+json": {
          "schema": {
            "properties": {
              "code": {
                "type": "string"
              },
              "request_id": {
                "type": "string"
              },
              "status": {
                "type": "number"
              },
              "title": {
                "type": "string"
              },
              "type": {
                "type": "string"
              }
            },
            "required": [
              "code",
              "status",
              "title",
              "type",
              "request_id"
            ],
            "type": "object"
          }
        }
      },
      "description": "Command refused"
    },
    "409": {
      "content": {
        "application/problem+json": {
          "schema": {
            "properties": {
              "code": {
                "type": "string"
              },
              "request_id": {
                "type": "string"
              },
              "status": {
                "type": "number"
              },
              "title": {
                "type": "string"
              },
              "type": {
                "type": "string"
              }
            },
            "required": [
              "code",
              "status",
              "title",
              "type",
              "request_id"
            ],
            "type": "object"
          }
        }
      },
      "description": "Command refused"
    },
    "428": {
      "content": {
        "application/problem+json": {
          "schema": {
            "properties": {
              "code": {
                "type": "string"
              },
              "request_id": {
                "type": "string"
              },
              "status": {
                "type": "number"
              },
              "title": {
                "type": "string"
              },
              "type": {
                "type": "string"
              }
            },
            "required": [
              "code",
              "status",
              "title",
              "type",
              "request_id"
            ],
            "type": "object"
          }
        }
      },
      "description": "Command refused"
    }
  },
  "summary": "Approve the current preview as a second staff member",
  "tags": [
    "bulk-operations"
  ],
  "x-audit": "ops.bulk.approve",
  "x-body": "none",
  "x-body-limit": 0,
  "x-concurrency": {
    "etag": true,
    "ifMatch": true
  },
  "x-idempotency": "required",
  "x-permission": "ops.bulk.execute",
  "x-reauth": true,
  "effectiveSecurity": []
}

POST /api/v1/admin/bulk-operations/{id}/cancel

POST /api/v1/admin/bulk-operations/{id}/cancel

cancel a bulk operation with If-Match

{
  "parameters": [
    {
      "in": "path",
      "name": "id",
      "required": true,
      "schema": {
        "format": "uuid",
        "type": "string"
      }
    },
    {
      "description": "Resource ETag; missing 428, malformed 412, stale 409.",
      "in": "header",
      "name": "If-Match",
      "required": true,
      "schema": {
        "type": "string"
      }
    }
  ],
  "responses": {
    "200": {
      "content": {
        "application/json": {
          "schema": {
            "properties": {
              "actions": {
                "items": {
                  "properties": {
                    "amount_minor": {
                      "type": "string"
                    },
                    "code_id": {
                      "format": "uuid",
                      "type": "string"
                    },
                    "currency": {
                      "type": "string"
                    },
                    "device_delta": {
                      "type": "number"
                    },
                    "expires_at": {
                      "type": "string"
                    },
                    "id": {
                      "type": "string"
                    },
                    "period_count": {
                      "type": "number"
                    },
                    "period_unit": {
                      "enum": [
                        "day",
                        "month",
                        "year"
                      ],
                      "type": "string"
                    },
                    "plan_ids": {
                      "items": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "type": "array"
                    },
                    "traffic_bytes": {
                      "type": "string"
                    },
                    "type": {
                      "enum": [
                        "term_extend",
                        "traffic_bonus",
                        "device_bonus",
                        "issue_coupon",
                        "gift_credit"
                      ],
                      "type": "string"
                    }
                  },
                  "required": [
                    "id",
                    "type"
                  ],
                  "type": "object"
                },
                "type": "array"
              },
              "audience": {
                "oneOf": [
                  {
                    "additionalProperties": false,
                    "properties": {
                      "emails": {
                        "default": [],
                        "items": {
                          "format": "email",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      },
                      "type": {
                        "enum": [
                          "list"
                        ],
                        "type": "string"
                      },
                      "user_ids": {
                        "default": [],
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 10000,
                        "type": "array"
                      }
                    },
                    "required": [
                      "type"
                    ],
                    "type": "object"
                  },
                  {
                    "additionalProperties": false,
                    "properties": {
                      "created_from": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "created_to": {
                        "format": "date-time",
                        "type": "string"
                      },
                      "has_active_subscription": {
                        "type": "boolean"
                      },
                      "invited_by": {
                        "format": "uuid",
                        "type": "string"
                      },
                      "locale": {
                        "maxLength": 35,
                        "type": "string"
                      },
                      "node_tags": {
                        "items": {
                          "maxLength": 64,
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "plan_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "server_ids": {
                        "items": {
                          "format": "uuid",
                          "type": "string"
                        },
                        "maxItems": 100,
                        "type": "array"
                      },
                      "status": {
[...]
